//
//  DeviceDiscoveryViewController.swift
//  MicrocomFirstApp
//
//  Created by Cameron Wrabel on 6/20/17.
//  Copyright © 2017 Cameron Wrabel. All rights reserved.
//

import UIKit

class DeviceDiscoveryViewController: UIViewController {

    //MARK: Properties
    @IBOutlet weak var discoverDevicesHeader: UILabel!
    
    var status: String = ""
    
    // udp variables
    
    
    
    
    override func viewDidLoad() {
        super.viewDidLoad()
        discoverDevicesHeader.text = "Discover Devices"
        // Do any additional setup after loading the view.
        
        sendBroadcastMessage(port: 30303)
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    
    // MARK: - Helper Functions
    
    // Uses UDP socket to listen for microcom devices on the network. 
    // The return value is a collection of MicrocomPrinterInfo objects, which contain values needed to populate the table cells. This function should listen, update if any responses are found, and keep working (and updating) in the background while the view controller is active
    func discoverDevices(timeoutInSeconds: UInt8) -> [MicrocomPrinterInfo] {
        
        var networkedMicrocomPrinters = [MicrocomPrinterInfo]()
        
        
        return networkedMicrocomPrinters
    }
    
    func sendBroadcastMessage(port: Int){
        
        var sock: Int32?
        var s_status: Int32
        var s_buflen: Int = 4096
        var s_inlen: socklen_t
        
        var buf: Array<CChar> = Array(repeating: 0, count: Int(s_buflen))
        var sock_in : sockaddr_in = sockaddr_in()
        var sock_out : sockaddr_in = sockaddr_in()
        var yes = 1
        
        var bcastAddr : String = "255.255.255.255"
        
        s_inlen = socklen_t(MemoryLayout<sockaddr_in>.size)
        //s_inlen = sockaddr_in.size
        memset(&sock_out, 0, Int(s_inlen))
        
        
        sock = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP)
        
        s_status = setsockopt(sock!, SOL_SOCKET, SO_BROADCAST, &yes, socklen_t(MemoryLayout<Int>.size));
        print("Setsockopt Status = \(s_status)");
        
        memset(&sock_in, 0, Int(s_inlen));
        sock_in.sin_family = sa_family_t(AF_INET);
        //sock_in.sin_addr.s_addr = inet_addr(bcastAddr);
        if (inet_aton(bcastAddr, &sock_in.sin_addr) == 0){
            print("Setting broadcast address to \(bcastAddr) failed.\n");
        }
        sock_in.sin_port = in_port_t(port)
        
        var bufferToSend : String = "Ciao"
        
//        buf[0] = CChar("C")!
//        buf[1] = CChar("i")!
//        buf[2] = CChar("a")!
//        buf[3] = CChar("o")!
        
        
        
        
//        let sockAddrFromSockIn_sendto = withUnsafePointer(to: &sock_in) {
//            $0.withMemoryRebound(to: sockaddr.self, capacity: 1){
//                s_status = Int32(sendto(sock!, &buf, Int(strlen(buf)), 0, UnsafePointer($0), s_inlen))
//
//            }
//        }
        let sockAddrFromSockIn_sendto = withUnsafePointer(to: &sock_in) {
            $0.withMemoryRebound(to: sockaddr.self, capacity: 1){
                s_status = Int32(sendto(sock!, &bufferToSend, 4, 0, UnsafePointer($0), s_inlen))
                
            }
        }
        
        //s_status = sendto(sock!, bufferToSend, bufferToSend.count, 0, UnsafePointer<sockaddr>(&sock_in), socklen_t(s_inlen))
        print("sendto status = \(s_status)")
        
        memset(&buf, 0, 4096)
        
        let sockAddrFromSockOut_recvfrom = withUnsafeMutablePointer(to: &sock_out){
            $0.withMemoryRebound(to: sockaddr.self, capacity: 1){
                s_status = Int32(recvfrom(sock!, &bufferToSend, s_buflen, 0, UnsafeMutablePointer($0), &s_inlen))
            }
        }
        print("recvfrom status = \(s_status)")
        
        var ipAddr: String = String(cString: inet_ntoa(sock_out.sin_addr))
        print("received ip address = \(ipAddr)")
        
        
        
        
    }
    

    /*
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        // Get the new view controller using segue.destinationViewController.
        // Pass the selected object to the new view controller.
    }
    */

}
