//
//  ImageEditOptionsTableViewController.swift
//  MicrocomFirstApp
//
//  Created by Microcom Developer on 7/17/17.
//  Copyright © 2017 Cameron Wrabel. All rights reserved.
//

import UIKit

class ImageEditOptionsTableViewController: UITableViewController {

    var imageSelectionVCReference: ImageSelectionViewController?
    
    var editOptionLabels: [String] = [String]()
    let editType: [String] = ["Color", "Crop", "Scale", "Flip", "Rotate"]
    var calledByEditType : String = ""
    var editTypeValue: String = ""
    
    // flip options
    let optionsFlip: [String] = ["Flip Vertically", "Flip Horizontally"]
    
    // rotate options
    let optionsRotate: [String] = ["Rotate Left", "Rotate Right"]
    
    // color options
    //let optionsColor: [String: Int] = ["Contrast" : 50, "Greyscale" : 1, "Bitonal" : 0, "WhiteThreshold" : 180]
    //let optionsColor: [String] = ["Greyscale", "Bitonal","Contrast",  "White Threshold"] // XXX
    let optionsColor: [String] = ["Contrast"]
    
    
    
    static public var optionsFlipValues: [String] = [String]()
    static public var optionsRotateValues: [String] = [String]()
    static public var optionsColorValues: [String] = [String]()
    static public var optionsCropValues: [String] = [String]()
    static public var optionsScaleValues: [String] = [String]()
    
    var numRowsDisplayed: Int = 0
    
    
    var shownTableView: UITableView?
    
    override func viewDidLoad() {
        super.viewDidLoad()

        if ImageEditOptionsTableViewController.optionsColorValues.count > 0 { // there are some values populating the list, i.e. this isn't the first time opening the color menu... keep those values
            
        }else{
            ImageEditOptionsTableViewController.optionsColorValues = ["50"]
        }
        
        // Uncomment the following line to preserve selection between presentations
        // self.clearsSelectionOnViewWillAppear = false

        // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
        // self.navigationItem.rightBarButtonItem = self.editButtonItem()
    }
    
//    override func viewWillAppear(_ animated: Bool) {
//        <#code#>
//    }
    
    
    override func viewWillDisappear(_ animated: Bool) {
        
        var cellDataReturned : [String] = [String]()
        
        print("--- in viewWillDisappear")
        
        // get the values of the displayed table cells
        switch calledByEditType {
            case "Color":
                //cellDataReturned = getCellData(editOptionType: calledByEditType, elementCount: 4) XXX
                cellDataReturned = getCellData(editOptionType: calledByEditType, elementCount: 1)
                
                ImageEditOptionsTableViewController.optionsColorValues = cellDataReturned
                
                
                break;
            case "Crop":
                
                break;
            case "Scale":
                
                break;
            case "Flip":
                cellDataReturned = getCellData(editOptionType: calledByEditType, elementCount: 2)
                ImageEditOptionsTableViewController.optionsFlipValues = cellDataReturned

                break;
            
            case "Rotate":
                cellDataReturned = getCellData(editOptionType: calledByEditType, elementCount: 2)
                ImageEditOptionsTableViewController.optionsRotateValues = cellDataReturned
                break;
            default:
                
                break;
        }
        
        print("---- calledByEdit type is \(calledByEditType)")
        print("---- cellDataReturned is \(cellDataReturned)")

    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

    // MARK: - Table view data source

    override func numberOfSections(in tableView: UITableView) -> Int {
        // #warning Incomplete implementation, return the number of sections
        return 1
    }

    // Creates the table based on the number of rows it should display
    override func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        // #warning Incomplete implementation, return the number of rows
        var numberOfRows = 0
        
        switch calledByEditType {
            case "Color":
                //numberOfRows = 4 // XXX
                numberOfRows = 1
                break;
            case "Crop":
                numberOfRows = 4
                break;
            case "Scale":
                numberOfRows = 1
                break;
            case "Flip":
                numberOfRows = 2
                break;
            case "Rotate":
                numberOfRows = 2
                break;
            default:
                break;
        }
        
        numRowsDisplayed = numberOfRows
        
        return numberOfRows
    }

    
    // creates the cell for each option. This decision is predicated on
    // the initial edit option that was selected, and the content of each sub option.
    override func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {

        
        // Configure the cell...
        if calledByEditType == "Flip" {
            
            let cell = tableView.dequeueReusableCell(withIdentifier: "ActionCell", for: indexPath) as! ActionTableViewCell
            
            let row = indexPath.row
            
            // if the cell is created again, re-use the values that we left off with last time
            let storedNumClicks = (ImageEditOptionsTableViewController.optionsFlipValues.count > row) ? UInt(ImageEditOptionsTableViewController.optionsFlipValues[row]) : 0
            
            
            cell.show(info: optionsFlip[row], actionimg: #imageLiteral(resourceName: "defaultMicrocomM"), numclicks: storedNumClicks!)
            return cell
            
            
        }
        else if calledByEditType == "Color" {
            
            let row = indexPath.row

            switch (optionsColor[row]){
                
                case "Contrast":
                    let cell = tableView.dequeueReusableCell(withIdentifier: "SliderCell", for: indexPath) as! SliderTableViewCell
                    
                    print("---in cell creation function case Color")
                    print("---- optionsColorValues is \(ImageEditOptionsTableViewController.optionsColorValues)")
                    
                    // implement the behavior for the closure
                    cell.onSliderChanged = {
                        self.reportSliderCellAction(editType: "Color", editOption: self.optionsColor[row], editValue: cell.m_sliderValue)
                    }
                    
                    // if the cell is created again, re-use the values that we left off with last time
                    let storedSliderVal = (ImageEditOptionsTableViewController.optionsColorValues.count > row) ? Int(ImageEditOptionsTableViewController.optionsColorValues[row]) : 50

                    cell.show(info: optionsColor[row], sliderval: storedSliderVal!)
                    return cell
                
                // XXX
//                case "White Threshold":
//
//                    let cell = tableView.dequeueReusableCell(withIdentifier: "SliderCell", for: indexPath) as! SliderTableViewCell
//
//                    // implement the behavior for the closure
//                    cell.onSliderChanged = {
//                        self.reportSliderCellAction(editType: "Color", editOption: self.optionsColor[row], editValue: cell.m_sliderValue)
//                    }
//
//                    // if the cell is created again, re-use the values that we left off with last time
//                    let storedSliderVal = (ImageEditOptionsTableViewController.optionsColorValues.count > row) ? Int(ImageEditOptionsTableViewController.optionsColorValues[row]) : 50
//
//                    cell.show(info: optionsColor[row], sliderval: storedSliderVal!)
//                    //cell.show(info: optionsColor[row], sliderval: 50)
//                    return cell
                
                //case "Greyscale",
                     //"Bitonal": // XXX 
//                case "Bitonal":
//
//                    editTypeValue = optionsColor[row]
//
//                    let cell = tableView.dequeueReusableCell(withIdentifier: "ToggleCell", for: indexPath) as! ToggleTableViewCell
//
//
//                    // implement the behavior for the closure
//                    cell.onToggleChanged = {
//
//                        self.reportToggleCellAction(editType: "Color", editOption: self.optionsColor[row], editValue: cell.m_switchValue)
//
//                    }
//
//                    // if the cell is created again, re-use the values that we left off with last time
//                    let storedToggleVal = (ImageEditOptionsTableViewController.optionsColorValues.count > row) ? Bool(ImageEditOptionsTableViewController.optionsColorValues[row]) : false
//
//                    cell.show(info: optionsColor[row], val: storedToggleVal!)
//                    //cell.show(info: optionsColor[row], val: false)
//                    return cell
                
                default:
                
                    let cell = tableView.dequeueReusableCell(withIdentifier: "ActionCell", for: indexPath) as! ActionTableViewCell
                    
                    cell.show(info: optionsColor[row], actionimg: #imageLiteral(resourceName: "defaultMicrocomM"), numclicks: 0)
                    return cell
                    
            }
            
            
            
            
        }
        else if calledByEditType == "Rotate" {
            
            
            let cell = tableView.dequeueReusableCell(withIdentifier: "ActionCell", for: indexPath) as! ActionTableViewCell
            
            let row = indexPath.row

            // if the cell is created again, re-use the values that we left off with last time
            let storedNumClicks = (ImageEditOptionsTableViewController.optionsRotateValues.count > row) ? UInt(ImageEditOptionsTableViewController.optionsRotateValues[row]) : 0
            cell.show(info: optionsRotate[row], actionimg: #imageLiteral(resourceName: "defaultMicrocomM"), numclicks: storedNumClicks!)
            
            return cell
            
            

        }
        else {
            let cell = tableView.dequeueReusableCell(withIdentifier: "Cell", for: indexPath)
            tableView.register(UITableViewCell.self, forCellReuseIdentifier: "Cell")
            cell.textLabel!.text = "Cell Label"
            
            return cell

        }

        //return cell
    }
    
    
    // gets the values of all of the visible cells and places them into a string array
    func getCellData(editOptionType: String, elementCount: Int) -> [String] {
        
        var cellData : [String] = [String]()
        let cells = self.tableView.visibleCells // the cells currently in view
        
        print("--- in getCellData: number of visibleCells is \(cells.count)")
        
        if cells.count != numRowsDisplayed {
            print("The number of visible cells did not match the currently selected row count")
            return cellData
        }
        else{
            
            // for each cell currently in view, find what type of cell it is so its value can be properly parsed
            for cell in cells {
                
                var valueOfCell : String = ""
                if cell is ToggleTableViewCell {
                    valueOfCell = "\((cell as! ToggleTableViewCell).m_switchValue)"
                }else if cell is SliderTableViewCell{
                    valueOfCell = "\((cell as! SliderTableViewCell).m_sliderValue)"
                }else if cell is ActionTableViewCell {
                    valueOfCell = "\((cell as! ActionTableViewCell).m_numClicks)"
                }
                
                cellData.append(valueOfCell)
                
            }
        }
        return cellData
    }
    
    
    
    
    override func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        let row = indexPath.row
        
        print("--- in didSelectRowAt")
        
//        if tableView.cellForRow(at: indexPath) is ActionTableViewCell {
//            (tableView.cellForRow(at: indexPath) as! ActionTableViewCell).m_numClicks += 1
//        }
        //var editType: String = calledByEditType
        var editOption: String = ""
        var editValue: String = ""
        
        
        switch calledByEditType {
            case "Flip":
                
                // increase the hit count for this cell
                if tableView.cellForRow(at: indexPath) is ActionTableViewCell {
                        (tableView.cellForRow(at: indexPath) as! ActionTableViewCell).m_numClicks += 1

                    editOption = optionsFlip[row]
                    editValue = "1"

                }
                break;
            case "Color":
                
                editTypeValue = optionsColor[row]
                
                // if the table cell is a toggle, append the toggle value
                if tableView.cellForRow(at: indexPath) is ToggleTableViewCell {
                    editOption = (ImageEditOptionsTableViewController.optionsColorValues[row])
                }
                
                // if the table cell is a slider, append the slider value
                if tableView.cellForRow(at: indexPath) is SliderTableViewCell {
                    editValue = (ImageEditOptionsTableViewController.optionsColorValues[row])
                }
                
                break;
            case "Rotate":
                if tableView.cellForRow(at: indexPath) is ActionTableViewCell {
                    (tableView.cellForRow(at: indexPath) as! ActionTableViewCell).m_numClicks += 1

                    editOption = optionsRotate[row]
                    editValue = "1"
                }
                break;
            default:
            
                break;
        }
        
        imageSelectionVCReference?.updateImageViewFromExternalSource(imgEditType: calledByEditType, imgEditOption: editOption, imgEditValue: editValue)
        
    }
    
    
    
    
    func doInitialTableCellSetup(_ cell: UITableViewCell, editType: String){
        
        if cell is ActionTableViewCell {
            (cell as! ActionTableViewCell).setDefaultValues()
        }
        else if cell is ToggleTableViewCell {
            (cell as! ToggleTableViewCell).setDefaultValues()
        }
        else if cell is SliderTableViewCell {
            (cell as! SliderTableViewCell).setDefaultValues()
        }

    }
    
    
    func reportToggleCellAction(editType: String, editOption: String, editValue: Bool){
        imageSelectionVCReference?.updateImageViewFromExternalSource(imgEditType: editType, imgEditOption: editOption, imgEditValue: editValue.description)
    }
    
    func reportSliderCellAction(editType: String, editOption: String, editValue: Int){
        imageSelectionVCReference?.updateImageViewFromExternalSource(imgEditType: editType, imgEditOption: editOption, imgEditValue: "\(editValue)")
    }
    
    
 

    /*
    // Override to support conditional editing of the table view.
    override func tableView(_ tableView: UITableView, canEditRowAt indexPath: IndexPath) -> Bool {
        // Return false if you do not want the specified item to be editable.
        return true
    }
    */

    /*
    // Override to support editing the table view.
    override func tableView(_ tableView: UITableView, commit editingStyle: UITableViewCellEditingStyle, forRowAt indexPath: IndexPath) {
        if editingStyle == .delete {
            // Delete the row from the data source
            tableView.deleteRows(at: [indexPath], with: .fade)
        } else if editingStyle == .insert {
            // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
        }    
    }
    */

    /*
    // Override to support rearranging the table view.
    override func tableView(_ tableView: UITableView, moveRowAt fromIndexPath: IndexPath, to: IndexPath) {

    }
    */

    /*
    // Override to support conditional rearranging of the table view.
    override func tableView(_ tableView: UITableView, canMoveRowAt indexPath: IndexPath) -> Bool {
        // Return false if you do not want the item to be re-orderable.
        return true
    }
    */

    /*
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        // Get the new view controller using segue.destinationViewController.
        // Pass the selected object to the new view controller.
    }
    */

}
