//
//  ImageSelectionViewController.swift
//  MicrocomFirstApp
//
//  Created by Cameron Wrabel on 6/26/17.
//  Copyright © 2017 Cameron Wrabel. All rights reserved.
//

import UIKit

class ImageSelectionViewController: UIViewController, UINavigationControllerDelegate, UIImagePickerControllerDelegate, UIPopoverPresentationControllerDelegate {
    
    //var printStreams: TCPSocks?
    
    // MagickWand for this view controller
    public var imagePrintWand: OpaquePointer?
    public var imageEditWand: OpaquePointer?
    //public var selectedImagePrintWand: OpaquePointer? // the wand containing the original image
    //public var imagePrintColorWand: OpaquePointer?
    
    var imageEditString: String = ""
    
   // @IBOutlet weak var microcomImageView: UIImageView!
    @IBOutlet weak var micImageView: UIImageView!
    @IBOutlet weak var imageViewBackground: UIView!
    @IBOutlet weak var filenameLabel: UILabel!
    @IBOutlet weak var lastEditString: UILabel!
    @IBOutlet weak var imageInfoButton: UIButton!
    
    @IBOutlet weak var editColorButton: UIButton!
    @IBOutlet weak var editScaleButton: UIButton!
    @IBOutlet weak var editCropButton: UIButton!
    @IBOutlet weak var editRotateButton: UIButton!
    @IBOutlet weak var editFlipButton: UIButton!
    
    @IBOutlet weak var bottomToolbar: UIToolbar!
    
    @IBOutlet weak var editButton: UIBarButtonItem!
    @IBOutlet weak var cancelButton: UIBarButtonItem!
    @IBOutlet weak var printButton: UIBarButtonItem!
    
    var popController: UIViewController?
    
    var isCurrentlyEditing: Bool = false
    var originalImage: UIImage?
    var editedImage: UIImage?
    
    var hasEdited: Bool = false
    
    @IBOutlet var imageSelectionTapRecognizer: UITapGestureRecognizer!
    
    //public var lastSelectedImagePNG: Data = UIImagePNGRepresentation(#imageLiteral(resourceName: "defaultMicrocomM"))!
    
    var tag: Int = 0
    
    // flip options
    let optionsFlipMenu: [String] = ["Flip Vertically", "Flip Horizontally"]
    
    // rotate options
    let optionsRotateMenu: [String] = ["Rotate Left", "Rotate Right"]
    
    // color options
    //let optionsColorMenu: [String] = ["Contrast", "Greyscale", "Bitonal", "White Threshold"] // XXX 
    let optionsColorMenu: [String] = ["Contrast"]
 
    
    override func viewDidLoad() {
        
        
        self.tag = 200
        
        super.viewDidLoad()
        
        cancelButton.isEnabled = false
        
        
        var bob = FileIOHelper.checkFileExists(filename: "imagePrintSelectedImage.png")
        if bob == false {
            micImageView.image = #imageLiteral(resourceName: "selectAnImage")
        }else{
            micImageView.image = FileIOHelper.loadImageFromPath(path: FileIOHelper.fileInDocumentsDirectory(filename:"imagePrintSelectedImage.png"))
        }
        
//        var imgSelect = 0
//        if imgSelect == 1 {
//            micImageView.image = #imageLiteral(resourceName: "selectAnImage")
//        }else{
//            micImageView.image = FileIOHelper.loadImageFromPath(path: FileIOHelper.fileInDocumentsDirectory(filename:"imagePrintSelectedImage.png"))
//        }
        //micImageView.image = FileIOHelper.loadImageFromPath(path: FileIOHelper.fileInDocumentsDirectory(filename:"imagePrintSelectedImage.png"))
        
        // disable the "edit image" buttons
        enableImageEditButtons(isEnabled: false)
//        editCropButton.isEnabled = false
//        editFlipButton.isEnabled = false
//        editColorButton.isEnabled = false
//        editScaleButton.isEnabled = false
//        editRotateButton.isEnabled = false

        // Do any additional setup after loading the view.
        MagickWandGenesis()
        //imagePrintWand = NewMagickWand()
        
    }
    
    override func viewWillDisappear(_ animated: Bool) {
        if editedImage != nil {
            //lastSelectedImagePNG = UIImagePNGRepresentation(editedImage!)!
        }else if originalImage != nil {
            //lastSelectedImagePNG = UIImagePNGRepresentation(originalImage!)!
        }else{
            // keep lastSelectedImagePNG
        }
        
        //ClearMagickWand(imagePrintWand)
        MagickWandTerminus()
        
    }
    
    override func viewWillAppear(_ animated: Bool) {
        MagickWandGenesis()
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    
    public func enableImageEditButtons(isEnabled: Bool){
        // toggle the the "edit image" buttons
        editCropButton.isEnabled = isEnabled
        editFlipButton.isEnabled = isEnabled
        editColorButton.isEnabled = isEnabled
        editScaleButton.isEnabled = isEnabled
        editRotateButton.isEnabled = isEnabled
        
        if isEnabled == true {
            self.editButton.title = "Done"
        }else{
            self.editButton.title = "Edit"
        }
        
        self.cancelButton.isEnabled = isEnabled
        self.printButton.isEnabled = !isEnabled
    }
    
    
    public func updateImageViewFromExternalSource(imgEditType: String, imgEditOption: String, imgEditValue: String){
        
        doImageMagickOperation(imgEditType, imgEditOption, imgEditValue)
        
        // TODO: this if structure was used to separate the color edit operations from the rotation/flip operations. 
        if(imgEditType == "Color"){
            // read the "color" edited file
            micImageView.image = UIImage(contentsOfFile: FileIOHelper.fileInDocumentsDirectory(filename: "magickEditedColorImage.png"))
            //MagickAddImage(imagePrintWand, imageEditWand)
            //MagickSetLastIterator(imagePrintWand)
            //MagickSetImage(imagePrintWand, imageEditWand)
        }else{
            MagickWriteImage(imagePrintWand, FileIOHelper.fileInDocumentsDirectory(filename: "magickEditedImage.png"))
            micImageView.image = UIImage(contentsOfFile: FileIOHelper.fileInDocumentsDirectory(filename: "magickEditedImage.png"))
        }
        
        //micImageView.image = UIImage(contentsOfFile: FileIOHelper.fileInDocumentsDirectory(filename: "magickEditedimage.png"))
        
        MagickWriteImage(imagePrintWand, FileIOHelper.fileInDocumentsDirectory(filename: "magickEditedImage.png"))
       // MagickWriteImage(imagePrintWand, FileIOHelper.fileInDocumentsDirectory(filename: "magick_edited_imagePrintSelectedImage.png"))
        
       // micImageView.image = UIImage(contentsOfFile: FileIOHelper.fileInDocumentsDirectory(filename: "magickEditedImage.png"))
        //micImageView.image = UIImage(contentsOfFile: FileIOHelper.fileInDocumentsDirectory(filename: "magick_edited_imagePrintSelectedImage.png"))
        
        
        
    }
    
    
    public func doImageMagickOperation(_ imgEditType: String, _ imgEditOption: String, _ imgEditValue: String){
        
        if (IsMagickWandInstantiated() == MagickFalse){
            MagickWandGenesis()
            imagePrintWand = NewMagickWand()
        }
        
        // check the edit type
        switch (imgEditType){
            
            case "Flip":
                
                if imgEditOption == "Flip Horizontally" {
                    MagickFlopImage(imagePrintWand) // horizontal
                    
                }else if imgEditOption == "Flip Vertically" {
                    MagickFlipImage(imagePrintWand) // vertical
                    
                }else{
                    print("Image edit value unknown")
                }
                break
            
            case "Rotate":
                
                var pixWand = NewPixelWand()
                
                if imgEditOption == "Rotate Left"{
                    MagickRotateImage(imagePrintWand, pixWand, 270.0)
                }
                else if imgEditOption == "Rotate Right"{
                    MagickRotateImage(imagePrintWand, pixWand, 90.0)

                }else{
                    print("Image edit option unknown")
                }
                
                DestroyPixelWand(pixWand)
                break
            
        case "Color":
            
            MagickReadImage(imageEditWand,FileIOHelper.fileInDocumentsDirectory(filename: "magickEditedImage.png"))
            
            // get the initial values that we might be changing
            var imgContrast: Double? = 0.0
            var imgBrightness: Double? = 0.0
            
            //var imgType: ImageType? = MagickGetImageType(imagePrintWand)
            //var imgColorspace: ColorspaceType? = MagickGetColorspace(imagePrintWand)
            
            if imgEditOption == ("Greyscale") {
                
                
                
                if(imgEditValue == ("true")){
                    //MagickSetImageColorspace(imagePrintWand, GRAYColorspace)
                    MagickNextImage(imagePrintWand)
                }else{
                    //MagickSetImageColorspace(imagePrintWand,RGBColorspace)
                    MagickPreviousImage(imagePrintWand)
                }
                
            }else if imgEditOption == ("Bitonal"){
                if(imgEditValue == ("true")){
                    //MagickNextImage(imagePrintColorBitonalWand) // move to the last iamge in the wand
                    MagickNextImage(imagePrintWand)
                    MagickSetImageType(imagePrintWand, BilevelType)
                    MagickSetImageColorspace(imagePrintWand, GRAYColorspace)
                    
                }else{
                    //MagickSetImageType(imagePrintWand,  )
                    //MagickPreviousImage(imagePrintColorBitonalWand) // go back to the previous, untouched image
                    MagickPreviousImage(imagePrintWand)
                }
                
            }else if imgEditOption == ("Contrast"){
                
                var contrastValue = imgEditValue
                
                var contrastDouble: Double? = Double(contrastValue)
            
                contrastDouble = contrastDouble! - 50.0
                contrastDouble = contrastDouble! * 2.0
                imgBrightness = 50.0
                //print("(brightness,contrast): \(imgBrightness),\(contrastDouble)")
                MagickModulateImage(imageEditWand, Double(contrastValue)!*2, 100, 100)
                
                
                MagickWriteImage(imageEditWand, FileIOHelper.fileInDocumentsDirectory(filename: "magickEditedColorImage.png") )


                //MagickBrightnessContrastImage(imagePrintWand, imgBrightness!, contrastDouble!)
                
            }else if imgEditOption == ("Brightness"){
                //MagickModulateImage(imagePrintWand, Double(contrastValue)!*2, 100, 100)
                
                //MagickModulateImage(imagePrintWand, Double(contrastValue)!*2, 100, 100)
                //MagickModulateImage(imageEditWand, Double(contrastValue)!*2, 100, 100)
               // print("magickModulateImage(brightness, saturation, hue): \(contrastValue),100,100")
                
            }else if imgEditOption == ("White Threshold"){
                
            }else{
                print("Image edit option unknown")
            }
            
            
            
            break
            
            default:
                print("Incorrect image edit type \(imgEditType)")
        }
        
        //FileIOHelper.writeTextToFile(text: "***Performing ImageMagick function***  \(imgEditType) , \(imgEditOption) , \(imgEditValue)", path: "IM_log.txt")
        
    }
    
    
    
    /************************************************/
    //MARK: Actions for Button Presses
    /************************************************/
    @IBAction func printButtonPressed(_ sender: UIBarButtonItem) {
        
        //var bob = TCPSocks(port: 1235,ip: "192.168.6.33")
        //bob.startTCPClient()
        
        //var bob = AppDelegate.printerConnection!
        
        if let currentConnection = AppDelegate.printerConnection {
            if currentConnection.hasStarted == 1 && currentConnection.isConnected == 1{
                
                var printWand = NewMagickWand()
                
                var imgPrint = LDS1ImagePrint()
                
                //imgPrint.prepareImageForMicrocomImagePrint(fileName: "imagePrintSelectedImage.png", wand: imagePrintWand)
                imgPrint.prepareImageForMicrocomImagePrint(fileName: "imagePrintSelectedImage.png", wand: printWand)
                
                //var imgHeight = MagickGetImageHeight(imagePrintWand)
                var imgHeight = MagickGetImageHeight(printWand)
                
                
                // do the image print
                imgPrint.performLDS1ImagePrint(stream: currentConnection, wand: printWand, width: 1280, height: imgHeight)
                
                ClearMagickWand(printWand)
                DestroyMagickWand(printWand)
                
            }            
            else{ // if the user has been disconnected, or the TCPSocks object is instantiated but hasStarted or isConnected != 1
                
                let alert = UIAlertController(title: "No Connection", message: "Return to the application home screen and enter the IP address and port of the printer, then click Connect.", preferredStyle: .alert)
                alert.addAction(UIAlertAction(title: NSLocalizedString("OK", comment: "Default action"), style: .`default`, handler: { _ in
                    NSLog("The \"OK\" alert occured.")
                }))
                
                self.present(alert, animated: true, completion: nil)
                
            }
        }else{ // if no connection has been made ever, or the printerConnection object is nil
            
            let alert = UIAlertController(title: "No Connection", message: "Return to the application home screen and enter the IP address and port of the printer, then click Connect.", preferredStyle: .alert)
            alert.addAction(UIAlertAction(title: NSLocalizedString("OK", comment: "Default action"), style: .`default`, handler: { _ in
                NSLog("The \"OK\" alert occured.")
            }))
            
            self.present(alert, animated: true, completion: nil)
            
        }
        
        
    }
    
    
    
    
    @IBAction func editButtonPressed(_ sender: Any) {
        
        if(editButton.title == "Edit"){
            
            hasEdited = true
            //cancelButton.isEnabled = true
            
            // grab the currently displayed image in the image view
            let imageForEdit = micImageView.image
            
            //save an untouched copy into document directory, this is so we can revert, undo changes
            //FileIOHelper.saveImage(image: imageForEdit!, path: "magick_original_imagePrintSelectedImage.png")
            
            //save into document directory; this will be our working copy
            FileIOHelper.saveImage(image: imageForEdit!, path: "magickEditedImage.png")
            
            // instantiate the magickwand
            imagePrintWand = NewMagickWand()
            
            // instantiate the magickwand for color operations
            imageEditWand = NewMagickWand()
            
            // load the image into the magick wand
            MagickReadImage(imagePrintWand, FileIOHelper.fileInDocumentsDirectory(filename: "magickEditedImage.png"))
            
            // enable the buttons for image editing, change the "edit" button to "done"
            enableImageEditButtons(isEnabled: true)
            
            //self.micImageView.gestureRecognizers.
            micImageView.isUserInteractionEnabled = false // disable the tap gesture recognizer
            
            
        }else if(editButton.title == "Done"){  // the user is done editing
            
            let imageToSave = micImageView.image
            
            FileIOHelper.saveImage(image: imageToSave!, path: "imagePrintSelectedImage.png")
            
            // enable the buttons for image editing, change the "done" button to "edit"
            enableImageEditButtons(isEnabled: false)
            
            ClearMagickWand(imagePrintWand)
            let fileWasRemoved: Bool =  FileIOHelper.removeFileFromDocumentDirectory(filename: "magickEditedImage.png")
            
            
            ClearMagickWand(imageEditWand)
            DestroyMagickWand(imageEditWand)
            let colorFileWasRemoved: Bool = FileIOHelper.removeFileFromDocumentDirectory(filename: "magickEditedColorImage.png")

            
            micImageView.isUserInteractionEnabled = true // re-enable the tap gesture recognizer
        }
        
        
    }
    
    
    @IBAction func undoButtonPressed(_ sender: Any) {
        
        // remove the temporary file
        let fileWasRemoved: Bool =  FileIOHelper.removeFileFromDocumentDirectory(filename: "magickEditedImage.png")
        
        // since editing was canceled, disable the image edit buttons
        enableImageEditButtons(isEnabled: false)
        
        // replace the image held by the image view with the original image
        micImageView.image = UIImage(contentsOfFile: FileIOHelper.fileInDocumentsDirectory(filename: "imagePrintSelectedImage.png"))
                
        ClearMagickWand(imagePrintWand)
        micImageView.isUserInteractionEnabled = true // re-enable the tap gesture recognizer

    }
    
    
    
    @IBAction func editColorButtonPressed(_ sender: UIButton) {

        
        MagickReadImage(imageEditWand, FileIOHelper.fileInDocumentsDirectory(filename: "magickEditedImage.png"))
        
        initializeImageEditPopover(editType: "Color", popWidth: 330, popHeight: 48*optionsColorMenu.count+2, sender: sender)
    }
    
    @IBAction func editFlipButtonPressed(_ sender: UIButton) {
        
        initializeImageEditPopover(editType: "Flip", popWidth: 330, popHeight: 48*optionsFlipMenu.count+2, sender: sender)
    }

    
    @IBAction func editScaleButtonPressed(_ sender: UIButton) {
        
        print("Scale\n");
        
        // test doing composite images. this is now used in LDS1ImagePrint.prepareImageForMicrocomImagePrint
//        var backgroundCanvas = NewMagickWand()
//        var pixWand = NewPixelWand()
//        PixelSetColor(pixWand, "white")
//
//
//
//        let imgHeight = MagickGetImageHeight(imagePrintWand)
//        let imgWidth = MagickGetImageWidth(imagePrintWand)
//        var xOffset: Int?
//        var yOffset: Int?
//
//        MagickNewImage(backgroundCanvas, 1280, 1280, pixWand)
//
//        if imgWidth < 1280 {
//            xOffset = (1280 - imgWidth)/2
//        }else{
//            xOffset = 0
//        }
//
//        if imgHeight < 1280 {
//            yOffset = (1280 - imgHeight)/2
//        }else{
//            yOffset = 0
//        }
//
//        MagickCompositeImage(backgroundCanvas, imagePrintWand, OverCompositeOp, xOffset!, yOffset!)
//
//        MagickWriteImage(backgroundCanvas, FileIOHelper.fileInDocumentsDirectory(filename: "magickPaddedImage.png"))
        
        
    }
    
    @IBAction func editCropButtonPressed(_ sender: UIButton) {
      
        print("Crop\n");
       
    }
    
    @IBAction func editRotateButtonPressed(_ sender: UIButton) {
        
        initializeImageEditPopover(editType: "Rotate", popWidth: 330, popHeight: 48*optionsRotateMenu.count+2, sender: sender)
    }
    
    
    func initializeImageEditPopover(editType: String, popWidth: Int, popHeight: Int, sender: UIButton){
        
        //print(editType)
        
        // get a reference to the view controller for the popover
        let popController = UIStoryboard(name: "Main", bundle: nil).instantiateViewController(withIdentifier: "imageEditPopoverID")
        
        (popController as! ImageEditOptionsTableViewController).calledByEditType = editType
        (popController as! ImageEditOptionsTableViewController).imageSelectionVCReference = self
        
        // set the presentation style
        popController.modalPresentationStyle = UIModalPresentationStyle.popover
        
        // set up the popover presentation controller
    popController.popoverPresentationController?.permittedArrowDirections = UIPopoverArrowDirection.down
        popController.popoverPresentationController?.delegate = self
        popController.popoverPresentationController?.sourceView = sender // button
        popController.popoverPresentationController?.sourceRect = sender.bounds
        print(sender.bounds.size)
        popController.preferredContentSize = CGSize(width: popWidth, height: popHeight)
        
        // present the popover
        self.present(popController, animated: true, completion: nil)
    }
    
    
    /************************************************/
    //MARK: PopoverPresentationControllerDelegate
    /************************************************/
    
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        //print("segue preparation")
        //segue for the popover configuration window
        if segue.identifier == "showEditPopoverSegue" {
            
            //self.present(popController!, animated: true, completion: nil)
            if let controller = segue.destination as? ImageEditOptionsTableViewController {
                //controller.popoverPresentationController!.delegate = self
                controller.preferredContentSize = CGSize(width: 270, height: 180)
                controller.calledByEditType = "Flip"
            }
        }
    }
    
    func popoverPresentationControllerDidDismissPopover(_ popoverPresentationController: UIPopoverPresentationController) {
        //do som stuff from the popover
        //print("dismissed popover")
    }
    
    func adaptivePresentationStyle(for controller: UIPresentationController) -> UIModalPresentationStyle {
        
        return UIModalPresentationStyle.none
    }
    
    
    /************************************************/
    //MARK: UIImagePickerControllerDelegate
    /************************************************/
    func imagePickerControllerDidCancel(_ picker: UIImagePickerController) {
        dismiss(animated: true, completion: nil)
    }
    
    func imagePickerController(_ picker: UIImagePickerController, didFinishPickingMediaWithInfo info: [String : Any]) {
        // use the original version of the image (several representations may exist of an image)
        guard let selectedImage = info[UIImagePickerControllerOriginalImage] as?
            UIImage else{
                fatalError("Expected a dictionary containing an image, but was provided the following: \(info)")
        }
        
        // set photoImageView to display the selected image
        micImageView.image = selectedImage
        
        //let tempImage = selectedImage
        //save into document directory
        //FileIOHelper.saveImage(image: tempImage, path: "imagePrintSelectedImage.png")
        FileIOHelper.saveImage(image: selectedImage, path: "imagePrintSelectedImage.png")

        
        //lastSelectedImagePNG = UIImagePNGRepresentation(tempImage)!
        
        
        
        //dismiss the picker
        dismiss(animated: true, completion: nil)
    }
    
    
    @IBAction func selectImageFromPhotoLibrary(_ sender: UITapGestureRecognizer) {
        // hide the keyboard
        
        
        // UIImagePickerController is a view controller that lets a user pick media from their photo library
        let micImagePickerController = UIImagePickerController()
        
        // ONly allow photos to be picked, not taken
        micImagePickerController.sourceType = .photoLibrary
        
        //notify viewController when user picks an image
        micImagePickerController.delegate = self
        present(micImagePickerController, animated: true, completion: nil)
        
    }


}
