//
//  MicrocomPrinterInfo.swift
//  MicrocomFirstApp
//
//  Created by Cameron Wrabel on 6/20/17.
//  Copyright © 2017 Cameron Wrabel. All rights reserved.
//

import UIKit

@IBDesignable class MicrocomPrinterInfo: UIStackView {

    //MARK: Properties
    private var infoLabels = [UILabel]()
    
    @IBInspectable var ipAddress: String = "" {
        didSet {
            setupLabels()
        }
    }
    @IBInspectable var serialNumber: String = "" {
        didSet {
            setupLabels()
        }
    }
    //@IBInspectable var ipLabel: UILabel = UILabel()
    //@IBInspectable var serialNumberLabel: UILabel = UILabel()
    
   //MARK: Initialization
    override init(frame: CGRect) {
        super.init(frame: frame)
        setupLabels()
    }
    
    required init(coder: NSCoder) {
        super.init(coder: coder)
        setupLabels()
    }
    
    private func setupLabels() {

        for label in infoLabels {
            removeArrangedSubview(label)
            label.removeFromSuperview()
        }
        infoLabels.removeAll()
        
        let ipLabel = UILabel()
        let serialNumberLabel = UILabel()
        
        
        ipLabel.text = "IP: \(ipAddress)"
        serialNumberLabel.text = "SN: \(serialNumber)"
        
        ipLabel.textColor = UIColor.gray
        serialNumberLabel.textColor = UIColor.gray
        
        ipLabel.translatesAutoresizingMaskIntoConstraints = false
        serialNumberLabel.translatesAutoresizingMaskIntoConstraints = false
        
        // add label to the stack
        addArrangedSubview(ipLabel)
        addArrangedSubview(serialNumberLabel)
        
        infoLabels.append(ipLabel)
        infoLabels.append(serialNumberLabel)
    }

}
