//
//  SliderTableViewCell.swift
//  MicrocomFirstApp
//
//  Created by Microcom Developer on 8/7/17.
//  Copyright © 2017 Cameron Wrabel. All rights reserved.
//

import UIKit

class SliderTableViewCell: UITableViewCell {

    var onSliderChanged : (() -> Void)? = nil
    
    @IBOutlet weak var infoLabel: UILabel!
    @IBOutlet weak var valueSlider: UISlider!
    @IBOutlet weak var valueLabel: UILabel!
    
    var m_infoLabelText : String = "InfoLabel"
    var m_valueLabelText : String = "Value"
    //var m_sliderValue : Float = 0.0 // default
    var m_sliderValue : Int = 0 // default
    
    var m_sliderMinimum : Float = 0.0 // default
    var m_sliderMaximum : Float = 100.0 // default
    
    @IBAction func sliderValueChanged(_ sender: UISlider, forEvent event: UIEvent) {
        
        valueLabel.text = "\(Int(sender.value))"
        m_sliderValue = Int(sender.value)
        m_valueLabelText = "\(Int(sender.value))"
        
        if let onSliderChanged = self.onSliderChanged {
            onSliderChanged()
        }
    }
    
    
    func show(info: String, sliderval: Int){
        m_infoLabelText = info
        m_valueLabelText = "\(sliderval)"
        //m_sliderValue = Int((m_sliderMinimum + m_sliderMaximum)/2)
        m_sliderValue = sliderval
        
        infoLabel.text = info
        valueSlider.value = Float(sliderval)
        valueLabel.text = "\(sliderval)"
        
    }
    
    func setDefaultValues(){
        m_infoLabelText = "InfoLabel"
        m_valueLabelText = "Value"
        
        m_sliderMinimum = 0.0
        m_sliderMaximum = 100.0
        m_sliderValue = Int((m_sliderMinimum + m_sliderMaximum)/2)
    }
    
    override func awakeFromNib() {
        super.awakeFromNib()
        // Initialization code
    }

    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)

        // Configure the view for the selected state
    }

}
