//
//  ToggleTableViewCell.swift
//  MicrocomFirstApp
//
//  Created by Microcom Developer on 8/8/17.
//  Copyright © 2017 Cameron Wrabel. All rights reserved.
//

import UIKit

class ToggleTableViewCell: UITableViewCell {

    var onToggleChanged : (() -> Void)? = nil
    
    @IBOutlet weak var infoLabel: UILabel!
    @IBOutlet weak var valueToggle: UISwitch!
    
    var m_infoLabelText : String = "Info"
    var m_switchValue : Bool = false
    
    @IBAction func toggleValueChanged(_ sender: UISwitch, forEvent event: UIEvent) {
        m_switchValue = valueToggle.isOn
        
        if let onToggleChanged = self.onToggleChanged {
            onToggleChanged()
        }
        // should call back to do a MagickWand operation
    }
    
    func show(info: String, val: Bool){
        m_infoLabelText = info
        m_switchValue = val
        
        infoLabel.text = info
        valueToggle.isOn = val
    }
    
    func setDefaultValues(){
        m_infoLabelText = "InfoLabel"
        m_switchValue = false
    }
    
    
    override func awakeFromNib() {
        super.awakeFromNib()
        // Initialization code
        //infoLabel.text = infoLabelText
        //valueToggle.isOn = switchValue
    }

    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)

        // Configure the view for the selected state
    }

}
