//
//  ViewController.swift
//  MicrocomFirstApp
//
//  Created by Cameron Wrabel on 5/30/17.
//  Copyright © 2017 Cameron Wrabel. All rights reserved.
//

import UIKit

//import SocketIO
import Foundation
import CoreFoundation




class ViewController: UIViewController, UITextFieldDelegate,
    UIImagePickerControllerDelegate, UINavigationControllerDelegate, StreamDelegate{
    //MARK: properties

    //@IBOutlet weak var connectDialogButton: UIButton!
    @IBOutlet weak var networkNameLabel: UILabel!
    @IBOutlet weak var networkNameTextField: UITextField!
    @IBOutlet weak var passwordTextField: UITextField! = UITextField()
    @IBOutlet weak var ipAddressTextField: UITextField!
    @IBOutlet weak var microcomImageView: UIImageView!
    @IBOutlet weak var sendMessageButton: UIButton!
    @IBOutlet weak var readMessageButton: UIButton!
    @IBOutlet weak var connectButton: UIButton!
    @IBOutlet weak var settingsBarButton: UIBarButtonItem!
    @IBOutlet weak var portNumberTextField: UITextField!
    @IBOutlet var editToolBar: UIToolbar!
    
    // This constraint ties an element at zero points from the bottom layout guide
    //@IBOutlet var keyboardHeightLayoutConstraint: NSLayoutConstraint?

    
    //var socket: SocketIOClient?
    //var sockad = sockaddr_in()
    var PortNumber: UInt32 = 1235
    var ipString = "127.0.0.1"
    //var ipString = "192.168.6.29"
    var inputStream : InputStream?
    var outputStream : OutputStream?
    
    var portStringFromAlert: String?
    var ipStringFromAlert: String?
    
    var output = ""
    //var stringToWrite = ""
    //var bufToWrite: [UInt8] = []
    var bufferSize = 1024
    
    var readFromServerString: String? = ""
//    static var readFromServerString: String? {
//
//        didSet {
//            //ViewController().updateTextField()
//
//        }
//
//    }
    
    var imageToPrint: CGImage?
    var rawImageData: Data?
    var imageHeight: Int?
    var imageWidth: Int?
    var imageData: [UInt8]?
    var counter: Int = 0
    
   // var oSelectedImage: UIImage?
   // var eSelectedImage: UIImage?
    
    
 
    
    //MARK: UI delegate views
    override func viewWillAppear(_ animated: Bool) {
        // 
        
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        // Handle text field's user input through delegate callbacks
        networkNameTextField.delegate = self
        ipAddressTextField.delegate = self
        passwordTextField.delegate = self
        portNumberTextField.delegate = self
        
        //readMessageButton.isEnabled = false
        //sendMessageButton.isEnabled = false
        
        //var printw = UserDefaults.standard.integer(forKey: "printWidth")
        //networkNameTextField.text = "\(printw)"
        
        
        //AppDelegate.printerConnection?.updateTextField = updateTextField
        

    }
    
    
    
    
    override func viewWillDisappear(_ animated: Bool) {
        //self.inputStream?.close()
        //self.outputStream?.close()
        
        self.resignFirstResponder()
        
    }
    

    //MARK: UITextFieldDelegate
    func textFieldShouldReturn(_ textField: UITextField) -> Bool{
        // Hide the keyboard
        textField.resignFirstResponder()
        return true
    }
    
    
    @IBAction func textFieldDidBeginEditing(_ sender: UITextField) {
        switch sender {
        case ipAddressTextField,
             //passwordTextField,
             networkNameTextField,
             portNumberTextField:
            
            sender.inputAccessoryView = editToolBar
            break
        default:
            break
        }
    }
    
    
    
    func textFieldDidEndEditing(_ textField: UITextField) {
        //networkNameLabel.text = networkNameTextField.text
    }
    
    //MARK: UIImagePickerControllerDelegate
    func imagePickerControllerDidCancel(_ picker: UIImagePickerController) {
        dismiss(animated: true, completion: nil)
    }
    
    func imagePickerController(_ picker: UIImagePickerController, didFinishPickingMediaWithInfo info: [String : Any]) {
        // use the original version of the image (several representations may exist of an image)
        guard let selectedImage = info[UIImagePickerControllerOriginalImage] as?
            UIImage else{
                fatalError("Expected a dictionary containing an image, but was provided the following: \(info)")
        }
        
        // set photoImageView to display the selected image
        microcomImageView.image = selectedImage
        
        let tempImage = selectedImage
        //save into document directory
        _ = FileIOHelper.saveImage(image: tempImage, path: "tempImage.png")
        
       
        
        //dismiss the picker
        dismiss(animated: true, completion: nil)
    }
    
    
    
    //MARK: Actions
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        if segue.identifier == "showDeviceDiscoveryViewController" {
            let deviceDiscoveryViewController = segue.destination as! DeviceDiscoveryViewController
            //deviceDiscoveryViewController.status = "Connected to bob"
        }
    }
    
   
    @IBAction func doneButtonPressed(_ sender: Any) {
        view.endEditing(true)
    }
    
    
    @IBAction func connectButtonPressed(_ sender: Any) {
        
        view.endEditing(true)
        resignFirstResponder()
        
        var shouldStartTCP: Bool = true
        
        
        // there is not a connection active, so we want to start a new one
        if ( connectButton.titleLabel!.text! == "Connect"){
            // first, validate the IP address before instantiating a TCP socket
            if( DataHelper.validateIPv4AddressString(ipAddressTextField.text!) == true){
                print("Valid IP")
                
                // if a valid ip is given, validate the port as well
                if( DataHelper.validatePortString(portNumberTextField.text!) == true){
                    print("Valid Port")
                    
                    // TODO: connect to a tcp sock
                    AppDelegate.printerConnection = TCPSocks(port: UInt32(portNumberTextField.text!)!, ip: ipAddressTextField.text!)
                    AppDelegate.printerConnection?.startTCPClient()
                    
                    if (AppDelegate.printerConnection?.isConnected == 1){
                        networkNameLabel.text = "Connected to \(AppDelegate.printerConnection!.IP)"
                        //connectButton.titleLabel!.text! = "Disconnect"
                        connectButton.setTitle("Disconnect", for: UIControlState.normal )
                    }
                    
                    
                }else{
                    print("Not a valid port")
                }
            }else{
                print("Not a valid IP")
                
                
            }
        }
        else { // there is an active connection, so disconnect it
            if(connectButton.titleLabel!.text! == "Disconnect"){
                print("Try to disconnect")
                
                //AppDelegate.printerConnection?.closeSocks()
                networkNameLabel.text = "No printer connection"
                connectButton.setTitle("Connect", for: UIControlState.normal )
                AppDelegate.printerConnection?.closeSocks()
            }
            
            
            
        }
        
    }
    
    
    @IBAction func setLabelText(_ sender: UIButton) {
        //networkNameLabel.text = "Connected to \(networkNameTextField.text!)"
        //var textread : String?
        if (ipAddressTextField.text?.isEmpty)! {
            ipAddressTextField.placeholder = "Enter an IP address..."
            ipAddressTextField.layer.borderColor = UIColor.red.cgColor
            
        } else {
            ipString = ipAddressTextField.text!
            //startTCPClient()
        }
        
        
    }
    
    @IBAction func sendMessageFromButton(_ sender: UIButton) {
        let messageText = networkNameTextField.text
        
        if(messageText != ""){
            passwordTextField.text = "" // clear the text in the box
            _ = AppDelegate.printerConnection?.writeToServer(message: messageText!)
            var bob = listenForServerMessage(timeToWait: 0)

        }
        //passwordTextField.text = "Test"
        
        //passwordTextField.text = AppDelegate.printerConnection?.getStringReceived()
        
    }
    
    func listenForServerMessage(timeToWait: UInt8) {
        
        DispatchQueue.global().asyncAfter(deadline: .now() + 1.0) {
            do {
                //try image = UIImage(data: Data(contentsOf: url))!
                self.readFromServerString = AppDelegate.printerConnection?.getStringReceived()
                
                try print("\(self.readFromServerString)")
            } catch {
                print("Failed")
            }
            
            DispatchQueue.main.async(execute: {
                if self.readFromServerString != "" {
                    let textToWrite: String = self.passwordTextField.text! + self.readFromServerString!
                    self.passwordTextField.text = textToWrite
                    
                }
            })
        }
    }
    
    @IBAction func readMessageFromButton(_ sender: UIButton) {
        //readFromServer()
       // var fname = FileIOHelper.fileInDocumentsDirectory(filename: "tempImage.png")
        //prepareImageForMicrocomImagePrint(fileName: fname)
    }
    
    
//    @IBAction func selectImageFromPhotoLibrary(_ sender: UITapGestureRecognizer) {
//        // hide the keyboard
//        networkNameTextField.resignFirstResponder()
//        ipAddressTextField.resignFirstResponder()
//        passwordTextField.resignFirstResponder()
//
//        // UIImagePickerController is a view controller that lets a user pick media from their photo library
//        let imagePickerController = UIImagePickerController()
//
//        // ONly allow photos to be picked, not taken
//        imagePickerController.sourceType = .photoLibrary
//
//
//        //notify viewController when user picks an image
//        imagePickerController.delegate = self
//        present(imagePickerController, animated: true, completion: nil)
//
//    }
    
    public func updateTextField(){
        //passwordTextField.text = ViewController.readFromServerString//AppDelegate.printerConnection?.readFromServerString
    }
    

}

